//
//    VME Data Readout Program
//
//    Copyright 2002-2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "QtSingleApplication/qtsinglecoreapplication.h"
#include <QTimer>

#include "daqapp.h"
#include "daqcommon/org.h"
#include "daqcommon/QtMessageUdpSender.h"
#include "colorlog/log.h"

DaqApp *daqApp = NULL;

int main(int argc, char **argv)
{
    QtSingleCoreApplication app(argc, argv);
    QCoreApplication::setOrganizationName(ORGANIZATION_NAME);
    QtMessageUdpSender logger;
    colorlog::set_debug_level(1);
    daqApp = new DaqApp(argc, argv, &app);
    app.connect(&app, SIGNAL(aboutToQuit()), daqApp, SLOT(cleanup()));
    QTimer timer(&app);
    app.connect(&timer, SIGNAL(timeout()), daqApp, SLOT(periodicTask()));
    timer.start(0);
    int rc = app.exec();
    delete daqApp;
    return rc;
}
