//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef DAQAPP_P_H
#define DAQAPP_P_H

#include <QSharedMemory>

class dvs_t;
struct shm_status_t;
struct shm_ctl_t;
struct shm_evlist_t;
struct shm_pio_rawdata_t;
class StartupConfig;

class DaqAppPrivate
{
public:
    DaqAppPrivate(const StartupConfig &config);
    ~DaqAppPrivate();
    void run_reset();
    void clear_shm_pio_rawdata();

    shm_status_t *createStatus();
    shm_ctl_t *createCtl();
    shm_evlist_t *createEvlist();
    shm_pio_rawdata_t *createRawdata();

private:
    StartupConfig * const startupConfig;

public:
    QSharedMemory shmStatus;
    QSharedMemory shmCtl;
    QSharedMemory shmEvlist;
    QSharedMemory shmRawdata;

    shm_status_t *shm_status;
    shm_pio_rawdata_t *shm_pio_rawdata;
    shm_evlist_t *shm_evlist;
    shm_ctl_t *shm_ctl;

private:
    void *createShm(QSharedMemory &shm, size_t size);
    void init_ipc (bool erase = false);
};

#endif // DAQAPP_P_H
