#ifndef SPILLMAN_H
#define SPILLMAN_H

#include <sys/time.h>
#include <list>
#include "daqcommon/daq_types.h"
#include "daqcommon/IpcShmStatus.h"

class SpillManager : public IpcShmStatus {
public:
    SpillManager(shm_status_t *status);
    void reset();
    void spill_start();
    void spill_stop();
    bool spill_started() const { return ((bs == BS_ON) || (bs == BS_OFF));}
    void update_rawdata_count(size_t bytes);
    void update_event_count(size_t events);
    unsigned int get_spill_count() const { return spill_count; }
    double getSpillTimeSeconds() const { return spillTimeSeconds; }
private:
    daq_spr_t getSpr() const;
    void setSpr(const daq_spr_t &spr);
    void clear_spr();
    void update_spr();
    void update_shm_status();
    struct timeval tv_burstreset, tv_endspill;

    std::list<struct timeval> sp_starts;
    burst_state_t bs;
    int spr_p;
    size_t raw_size, bsizep, ev_count, ev_countp;
    unsigned int spill_count;
    double spillTimeSeconds;
};

#endif /* SPILLMAN_H */
