#ifndef _STORAGE_H
#define _STORAGE_H

#include <QtGlobal>
#include <QString>
#include "daqcommon/daq_types.h"
#include "daqcommon/daq_ipc.h"
#include "daqcommon/IpcShmStatus.h"

class Storage : public IpcShmStatus {
public:
    Storage(shm_status_t *status);
    ~Storage();

    qint64 getnb () const;
    void preparerun ();
    int start_of_spill ();
    bool flush ();
    int write (const dma_buf_t *buf, int start, int end);
    static QString DEFAULT_STORAGE_FILENAME();

protected:
    bool isInitialized() const { return storage_initialized; }
    void setopt (bool store, bool cyclic);
    void setfn (const QString &fn);
    void update_setup();
    void update_statistics();

    QString STORAGE_FILENAME;
    QString STORAGE_FILENAME_TMP;

    bool storage_initialized;
    bool enable_storage;
    bool storage_cyclic;
};

#endif /* _STORAGE_H */
