#ifndef _DAQCFG_H
#define _DAQCFG_H

#include <QObject>

#include "daqcommon/daq_types.h"

class daqcfg_t {
public:
    daqcfg_t(): dec_en(true), hist_en(true), hist_downscale(1), hist_clear_by_burst(false), tdcCommonStopChannel(0) {}
    bool dec_en;
    bool hist_en;
    int hist_downscale;
    bool hist_clear_by_burst;
    int tdcCommonStopChannel;
    QString currentHistName;
};

class DaqCfg : public QObject
{
    Q_OBJECT

public:
    DaqCfg();
    virtual ~DaqCfg();

    void load();
    void save() const;

    bool get_dec_en() const;
    void set_dec_en(bool state);

    bool get_hist_en() const;
    void set_hist_en(bool state);

    int get_hist_downscale() const;
    void set_hist_downscale(int value);

    bool get_hist_clear_by_burst() const;
    void set_hist_clear_by_burst(bool state);

    int getTdcCommonStopChannel() const;
    void setTdcCommonStopChannel(int);

    QString getCurrentHist() const;
    void setCurrentHist(const QString &);

Q_SIGNALS:
    void changed();

private:
    daqcfg_t * const data;
};

#endif                          /* _DAQCFG_H */
