
#include "main.h"

#include <QDebug>
#include <QApplication>
#include <QTextCodec>

#include <stdexcept>

#include "daqgui.h"
#include "daqcommon/org.h"

int main (int argc, char **argv)
{
    int rc=1;

    QTextCodec::setCodecForCStrings(QTextCodec::codecForName("utf8"));

    try {
        QApplication a (argc, argv);
        QCoreApplication::setOrganizationName(ORGANIZATION_NAME);
//        QCoreApplication::setApplicationName(APPLICATION_NAME); // don't set it
        DaqGui *w = new DaqGui;
        a.setMainWidget(w);
        w->show();
        a.connect(&a, SIGNAL (lastWindowClosed()), &a, SLOT (quit()));
        rc= a.exec();
	delete w;
    }
    catch (std::runtime_error & e) {
        qFatal(QString("Fatal run-time error: %1").arg(e.what()).toAscii());
    }
    catch (std::exception & e) {
        qFatal(QString("Fatal exception: %1").arg(e.what()).toAscii());
    }
    return rc;
}
