
#include "qutil.h"

#include <QWidget>
#include <QCursor>
#include <QApplication>

localWaitCursor::localWaitCursor(QWidget *w)
    : widget(w)
{
    if (widget) {
        save_cursor = widget->cursor();
        widget->setCursor(Qt::WaitCursor);
    }
}

localWaitCursor::~localWaitCursor()
{
    if (widget)
        widget->setCursor(save_cursor);
}


globalWaitCursor::globalWaitCursor()
{
    qApp->setOverrideCursor(Qt::WaitCursor);
}

globalWaitCursor::~globalWaitCursor()
{
    qApp->restoreOverrideCursor();
}

TemporaryWidgetDisabler::TemporaryWidgetDisabler(QWidget *p)
    : widget(p)
{
    saveState = widget->isEnabled();
    widget->setEnabled(false);
}

TemporaryWidgetDisabler::~TemporaryWidgetDisabler()
{
    widget->setEnabled(saveState);
}
