//
//    Copyright 2003-2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef STARTDAQ_H
#define STARTDAQ_H

#include <QDialog>

namespace Ui {
    class StartDAQBase;
};

class runparam_t;

class StartDAQ: public QDialog
{

    Q_OBJECT

public:
    explicit StartDAQ(QWidget* parent=0);
    virtual ~StartDAQ();
    void setdata(const runparam_t &data_in);
    runparam_t getdata() const;

public Q_SLOTS:
    void accept();

private:
    void updateRawFileName();
    QString makeRawFileName();
    void restore();
    void updateFilenameDisplay();
    void updateEnabled();
    void le_fn_accept();
    void le_rd_accept();

    Ui::StartDAQBase * const ui;
    runparam_t * const data;

private Q_SLOTS:
    void on_pb_Browse_clicked();
    void on_cb_stor_toggled(bool checked);
    void on_cb_recycle_toggled( bool state );
};

#endif /* STARTDAQ_H */
