
#include "sysmon.h"

#include <QDebug>

#include "sysmon_impl.h"

SystemMonitor::SystemMonitor()
    : impl(new SystemMonitorImpl())
{
}

SystemMonitor::~SystemMonitor()
{
    delete impl;
}

void SystemMonitor::print() const
{
    qDebug() << "--- System Monitor ---";
    const data_t data = impl->get_all();
    Q_FOREACH(QString name, data.keys()) {
        const QString &value = data[name];
        if (name.isNull() || value.isNull()) continue;
        qDebug() << name << "=" << value;
    }
    qDebug() << "-------------------------";
}

const QString SystemMonitor::get(const QString & name) const
{
    return impl->get(name);
}
