#ifndef SYSMON_IMPL_H
#define SYSMON_IMPL_H

#include <qobject.h>
#include <qstringlist.h>
#include <qmutex.h>
#include <qmap.h>
#include <time.h>

typedef QMap<QString,QString> data_t;
typedef QMap<QString,QStringList> sysstats_t;

class SystemMonitorImpl: public QObject {

public:
  SystemMonitorImpl();
  const QString get(const QString & name) const;
  const data_t get_all() const;

private:
  void read() const;
  void read_meminfo() const;
  void read_stat() const;
  void check_update() const;
  mutable data_t data;
  mutable time_t last_updated;
  mutable sysstats_t last_sysstats;
  mutable QMutex mutex;
};

#endif /* SYSMON_IMPL_H */
