
#include "tqdc_waveformview.h"

#include <iostream>

#include "wfdata.h"
#include "daqcommon/hptimer.h"
#include "decoder/event.h"

TQDC_WaveformView::TQDC_WaveformView(QWidget *p)
    : WaveformView(p)
{
}

void TQDC_WaveformView::add_event(const event_t &ev)
{
  if (ev.evtype != EVT_NORM) return;
  hpTimer hpt;
  hpt.start();
//  if (!ev) return;
//  const trig_event_t &trig = ev->trig;
  const tqdc_event_t &tqdc = ev.tqdc;
//  WaveformDataAll &wd(cache);
//  const tqdc_hits_q_t &hits_q = tqdc.hits_q;
//  const tqdc_hits_t_t &hits_t = tqdc.hits_t;
  const tqdc_wfs_t &wfs = tqdc.wfs;
//  const tqdc_cnts_t &cnts = tqdc.cnts;
  WaveformDataAll wda;
//  wd.resize(wfs.size());
  Q_FOREACH(int ch, wfs.keys()) {
        const tqdc_wfv_t &wfv = wfs.value(ch);
        Q_FOREACH(const tqdc_wf_t &wf, wfv) {
          WaveformData wd;
          wd.c = ch;
// BUG: multiple waveforms may be available for given ch while hitv_t is only one
//	const tqdc_hitv_t_t &hitv_t = hits_t[ch];
//    wd.t = hitv_t;
//    printf("wf %d: ch %d, len %d\n", n, wf->ch, wf->len);
    //      printf("ev %d, wf %d: ch %d, len %d\n", ev->en, n, wf->ch, wf->len);
        wd.p.resize(wf.samp.size());
// get timestamp
//	int trig_ts = tqdc.ts;
//	unsigned int ts = 0;
//	if (tqdc.n_q >= n)
//	  ts = tqdc.hits_q[n].ts;
//    for (uint t=0;t<tqdc.n_q;t++)
//  	  if (tqdc.hits_q[t].ch == wf.ch)
//  		ts = tqdc.hits_q[t].ts;
        int ts = wf.ts;
    for (int i=0;i<wf.samp.size();i++) {
          wd.p[i].x = ((int)i + ts)*0.01; // us
          wd.p[i].y = wf.samp[i];
    }
//	wd.print();
        wda.push_back(wd);
        }
  }

  hpt.stop();
//  double dt = hpt.elapsed();
//  stats->add("TQDC_WaveformView::add_event time", dt);
  setWaveformData(wda);
//  update();
}

void TQDC_WaveformView::simulate()
{
  WaveformDataSimulator sim;
  WaveformDataAll wd(sim.run());
  setWaveformData(wd);
  update();
}
