//
//    Copyright 2003-2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "triggersview.h"
#include "ui_triggersviewbase.h"

TriggersView::TriggersView(QWidget* parent)
    : QDialog(parent),
    ui(new Ui::TriggersViewBase)
{
    ui->setupUi(this);
    setModal(false);
    update();
}

TriggersView::~TriggersView()
{
    delete ui;
}

void TriggersView::update()
{
    if (!isShown()) return;
    ui->waveformViewTriggersView->update();
}

void TriggersView::burstreset()
{
    clear();
}

void TriggersView::end_of_burst()
{
    ui-> waveformViewTriggersView->write_file();
}

void TriggersView::clear()
{
    ui->waveformViewTriggersView->clear();
}

void TriggersView::addEvent( const event_t &ev )
{
    ui-> waveformViewTriggersView->add_event(ev);
}
