
#include "comgui/dataplot.h"
#include "waveformsmodel.h"
#include <QDebug>

void WaveformsModel::resize (const unsigned int new_nch, const unsigned int new_len)
{
  len = new_len;
  nch = new_nch;
  en_plot.resize (len, true);
  map_to_plot.resize (len, 0);
  average.resize (len);
  average_count.resize (len, 0);

//  cache.resize (len, 0);

  px.resize (len);
  for (uint i = 0; i < px.size (); i++)
    px[i] = i;

  py.resize (nch);
  for (uint c = 0; c < py.size (); c++)
    py[c].resize (len, 0);

  pn.resize (nch);
}

WaveformsModel::~WaveformsModel ()
{
}

WaveformsModel::WaveformsModel ()
: nch(0), iclip_detected(false)
{
  len = 0;
  cur_ch = 0;
  /*
     map_to_plot = new int[nch];
     en_plot = new int[nch];
     average = new average_adc_wf_t[nch];
     average_count = new int[nch];
     for (int c = 0; c < nch; c++) {
     map_to_plot[c] = 0;
     en_plot[c] = c < DataPlot_NCH;
     average_count[c] = 0;
     average[c] = new double[len];
     for (int i = 0; i < len; i++) {
     average[c][i] = 0;
     }
     }
     cache = new adc_sample_t[len];
     for (int i = 0; i < len; i++) {
     cache[i] = 0;
     }

     px = new double[len];
     for (int c = 0; c < DataPlot_NCH; c++) {
     py[c] = new double[len];
     }
     for (int i = 0; i < len; i++) {
     px[i] = i;
     for (int c = 0; c < DataPlot_NCH; c++)
     py[c][i] = 0;
     }
   */
  // presets...
  autoscale = true;
  averaging = false;
  scale_min = -512;
  scale_max = 511;

  return;
  //enomem:
  //  abort();
}

void WaveformsModel::clear_average ()
{
  for (uint c = 0; c < average_count.size (); c++) {
    average_count[c] = 0;
    for (uint i = 0; i < average[c].size (); i++)
      average[c][i] = 0;
  }
}

void WaveformsModel::remap_adc_to_plot ()
{
  for (uint i = 0; i < nch; i++)
    map_to_plot[i] = -1;

  uint max = nch;
  if (max > DataPlot_NCH)
    max = DataPlot_NCH;
  for (uint i = 0; i < max; i++)
    map_to_plot[i] = i;
//  print_adc_chidx ();

//  qDebug() << map_to_plot;
}

int WaveformsModel::map_to_adc_ch (const int nplot) const
{
  if (nplot < 0)
    return -1;
//  for (int i = 0; i < nch; i++)
//    if (map_to_plot[i] == nplot)
//      return (i);
  if (nplot < int(nch)) return nplot;
  return -1;
}
