//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//


#ifndef QDEBUGFORMATTER_H
#define QDEBUGFORMATTER_H

#include <vector>
#include <QDebug>

template<class T>
QDebug &operator<<(QDebug &s, const std::vector<T> &v)
{
    typedef typename std::vector<T>::const_iterator Iter;
    s.nospace() << "{";
    Iter it = v.begin();
    while (it!=v.end()) {
        if (it!=v.begin()) s.nospace() << ", ";
        s.nospace() << (*it);
        ++it;
//        Iter tmp = it;
//        int n=1;
//        while((it != v.end()) && (*tmp == *it)) {++it; n++;}
//        if (n>1) {
//            s.nospace() << " (" << n << " times)";
//            n=0;
//        }
    }
    s.nospace() << "}";
    return s.maybeSpace();
}

#endif // QDEBUGFORMATTER_H
