//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "QtMessageHandler.h"
#include <QtGlobal>
#include <QDateTime>
#include <iostream>
#include <cstdlib>
#include "QtMessageTypes.h"

void QtMessageHandler::myMessageOutput(QtMsgType type, const char *text)
{
    QtMessage message(QDateTime::currentDateTime(), type, text);
    Q_EMIT GlobalQtMessageHandler::Instance()->qtMessage(message);
    if (type == QtFatalMsg) {
        std::cerr << "Fatal: " << text << std::endl;
        abort();
    }
}

void QtMessageHandler::myMessageOutput(const QtMessage &message)
{
    Q_EMIT GlobalQtMessageHandler::Instance()->qtMessage(message);
    if (message.type == QtFatalMsg) {
        std::cerr << "Fatal: " << message.text.toStdString() << std::endl;
        abort();
    }
}

QtMessageHandler::QtMessageHandler()
{
    qInstallMsgHandler(myMessageOutput);
}
