//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef QTMESSAGEHANDLER_H
#define QTMESSAGEHANDLER_H

#include "decoder/singleton.h"
#include <QObject>

class QString;
class QtMessage;

class QtMessageHandler : public QObject
{
    Q_OBJECT
public:
    QtMessageHandler();
    static void myMessageOutput(const QtMessage &message);
Q_SIGNALS:
//    void qtMessage(QtMsgType priority, const QString &text);
    void qtMessage(const QtMessage &message);
private:
    static void myMessageOutput(QtMsgType type, const char *text);
};

class GlobalQtMessageHandler : public Singleton<QtMessageHandler>
{
protected:
    GlobalQtMessageHandler() {}
    friend class Singleton<QtMessageHandler>;
};

#endif // QTMESSAGEHANDLER_H

