//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "QtMessageTypes.h"

#include <QDataStream>
#include <QVariant>

QDataStream &operator<<(QDataStream &stream, const QtMessage &message)
{
    stream << message.date;
    stream << int(message.type);
    stream << message.text;
    return stream;
}

QDataStream &operator>>(QDataStream &stream, QtMessage &message)
{
    stream >> message.date;
    int type;
    stream >> type;
    message.type = QtMsgType(type);
//    if (type.canConvert<QtMsgType>())
//        message.type = type.value<QtMsgType>();
//    else
//        stream.setStatus(QDataStream::ReadCorruptData);
    stream >> message.text;
    return stream;
}
