//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef QTMESSAGETYPES_H
#define QTMESSAGETYPES_H

#include <QtCore/QtGlobal>
#include <QDateTime>
#include <QMetaType>

const quint16 QtMessageUdpPort = 48777;

class QDataStream;

class QtMessage {
public:
    QtMessage() : type(QtWarningMsg) {}
    QtMessage(const QDateTime &_date, const QtMsgType &_type, const QString &_text)
        : date(_date), type(_type), text(_text) {}
    QDateTime date;
    QtMsgType type;
    QString text;
};
Q_DECLARE_METATYPE(QtMessage);
Q_DECLARE_METATYPE(QtMsgType);

QDataStream &operator<<(QDataStream &stream, const QtMessage &message);
QDataStream &operator>>(QDataStream &stream, QtMessage &message);

#endif // QTMESSAGETYPES_H
