
#include "RunStateTransitionRules.h"
#include <map>

bool RunStateTransitionRules::isAllowed(daq_state_t from, daq_state_t to)
{
    // any state accepted
    if (to == ST_OFF) return true;
    if (to == ST_INIT) return true;
    if (to == ST_FAIL) return true;

    std::map<daq_state_t, std::map<daq_state_t, bool> > m;
    // RESET
    m[ST_INIT][ST_RESET] = true;
    m[ST_RESET][ST_RESET] = true;
    m[ST_PREPARERUN][ST_RESET] = true;
    m[ST_RUN][ST_RESET] = true;
    m[ST_PAUSE][ST_RESET] = true;
    // PREPARERUN
    m[ST_RESET][ST_PREPARERUN] = true;
    m[ST_PREPARERUN][ST_PREPARERUN] = true;
    m[ST_PAUSE][ST_PREPARERUN] = true;
    // RUN
    m[ST_PREPARERUN][ST_RUN] = true;
    m[ST_PAUSE][ST_RUN] = true;
    // PAUSE
    m[ST_RUN][ST_PAUSE] = true;

    return m[from][to];
}
