//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "TimerStarter.h"

#include <QTimer>

TimerStarterOnDestruct::TimerStarterOnDestruct(QTimer *timer, int msec, bool sshot)
    : p_timer(timer), p_msec(msec), p_sshot(sshot)
{
}

TimerStarterOnDestruct::~TimerStarterOnDestruct()
{
    p_timer->setSingleShot(p_sshot);
    p_timer->start(p_msec);
}
