//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "daqcommon/ansi_col.h"

#ifndef _WIN32
const char *ANSI_NORM = "\E[0m";
const char *ANSI_BOLD = "\E[1m";
const char *ANSI_BLINK = "\E[5m";
const char *ANSI_REV = "\E[7m";
const char *ANSI_BLACK = "\E[30;1m";
const char *ANSI_RED = "\E[31;1m";
const char *ANSI_GREEN = "\E[32;1m";
const char *ANSI_YELLOW = "\E[33;1m";
const char *ANSI_BLUE = "\E[34;1m";
const char *ANSI_MAGENTA = "\E[35;1m";
const char *ANSI_CYAN = "\E[36;1m";
const char *ANSI_WHITE = "\E[37;1m";
const char *ANSI_DEFAULT = "\E[39;1m";
const char *ANSI_BGR_BLACK = "\E[40;1m";
const char *ANSI_BGR_RED = "\E[41;1m";
const char *ANSI_BGR_GREEN = "\E[42;1m";
const char *ANSI_BGR_YELLOW = "\E[43;1m";
const char *ANSI_BGR_BLUE = "\E[44;1m";
const char *ANSI_BGR_MAGENTA = "\E[45;1m";
const char *ANSI_BGR_CYAN = "\E[46;1m";
const char *ANSI_BGR_WHITE = "\E[47;1m";
const char *ANSI_BGR_DEFAULT = "\E[49;1m";
const char *XTERM_CLEAR = "\E[H\E[2J";
#else
const char *ANSI_NORM = "";
const char *ANSI_BOLD = "";
const char *ANSI_BLINK = "";
const char *ANSI_REV = "";
const char *ANSI_BLACK = "";
const char *ANSI_RED = "";
const char *ANSI_GREEN = "";
const char *ANSI_YELLOW = "";
const char *ANSI_BLUE = "";
const char *ANSI_MAGENTA = "";
const char *ANSI_CYAN = "";
const char *ANSI_WHITE = "";
const char *ANSI_DEFAULT = "";
const char *ANSI_BGR_BLACK = "";
const char *ANSI_BGR_RED = "";
const char *ANSI_BGR_GREEN = "";
const char *ANSI_BGR_YELLOW = "";
const char *ANSI_BGR_BLUE = "";
const char *ANSI_BGR_MAGENTA = "";
const char *ANSI_BGR_CYAN = "";
const char *ANSI_BGR_WHITE = "";
const char *ANSI_BGR_DEFAULT = "";
const char *XTERM_CLEAR = "";
#endif
