#ifndef _BITOP_H
#define _BITOP_H 1

template<class F, class M>
void set_flag_value(F *d, M mask, bool state)
{
    if (state) *d |= mask;
    else *d &= ~mask;
}

template<class F, class M>
bool get_flag_value(F d, M mask) {

    return (d & mask) == mask;
}

//void set_bit_value(int *d, int mask, bool state);
//bool get_bit_value(int d, int mask);

//! number of bytes required to store x bits
unsigned int BYTES_FOR_BITS(unsigned int x);

void bitcopy (void *dst, unsigned int doff, const void *src, unsigned int soff, unsigned int len);
int bitcmp (const void *in, const void *out, unsigned int len);
void bitprintdiff (const void *in, const void *out, unsigned int len);
void bitprintdiff_groups (const void *in, const void *out, unsigned int len, unsigned int bit_per_group);
void bitprint (const void *in, unsigned int len);
void bitprint_groups (const void *in, unsigned int len, unsigned int bit_per_group);

#endif   /* _BITOP_H */
