#ifndef DAQ_TYPES_H
#define DAQ_TYPES_H

enum daq_state_t { ST_OFF, ST_INIT, ST_RESET, ST_PREPARERUN, ST_RUN, ST_PAUSE, ST_FAIL };
enum burst_state_t { BS_OFF, BS_ON };

typedef unsigned int dma_buf_t;

struct dma_stat_t {
  unsigned long ndma;         /*  count */
  unsigned long nover;        /* number of fifo overruns - DI */
};

enum { DAQ_SPR_LEN = 200 };         /* number of points */
enum { DAQ_SPR_NUM = 8 };           /* number of graphs */
typedef double daq_spr_pt;
struct daq_spr_t {
  double time;            // sph time, sec - full scale
  int end;                // last valid position
  daq_spr_pt v[DAQ_SPR_NUM][DAQ_SPR_LEN];
};

#endif /* DAQ_TYPES_H */
