
// exceptions

#ifndef DAQEXC_H
#define DAQEXC_H

#include <exception>
#include <stdexcept>
#include <string>

class exc: public std::runtime_error {
public:
    exc(const std::string &s) : std::runtime_error(s) {}
};

class exc_badcode: public exc {
public:
  exc_badcode(const std::string &s) : exc(s) {};
};
class exc_hw: public exc {
public:
  exc_hw(const std::string &s) : exc(s) {};
};
class exc_hwif: public exc_hw {
public:
  exc_hwif(const std::string &s) : exc_hw(s) {};
};

class exc_vme: public exc_hw {
public:
  exc_vme(const std::string &s) : exc_hw(s) {};
};
class exc_vme_berr: public exc_vme {
public:
  exc_vme_berr(const std::string &s) : exc_vme(s) {};
};
class exc_vme_tmout: public exc_vme_berr {
public:
  exc_vme_tmout(const std::string &s) : exc_vme_berr(s) {};
};
class exc_vme_nack: public exc_vme_berr {
public:
  exc_vme_nack(const std::string &s) : exc_vme_berr(s) {};
};

class exc_base_mod: public exc {
public:
  exc_base_mod(const std::string &s) : exc(s) {};
};

class exc_mod_unknown_tag: public exc_base_mod {
public:
  exc_mod_unknown_tag(const std::string &s) : exc_base_mod(s) {};
};


class exc_decoder: public exc {
public:
  exc_decoder(const std::string &s) : exc(s) {};
};

class exc_cal_not_found: public exc {
public:
  exc_cal_not_found(const std::string &s) : exc(s) {};
};

#endif /* DAQEXC_H */
