#ifndef DSPLIB_H
#define DSPLIB_H

// Gaussian function FWHM constant (sigma to width conversion)
// sqrt(2*log(2))
const double GausFWHM = 2.35482004503094933e+00;

// An unnormalized gaussian function with mean=0 and sigma
// Divide result by sqrt(2*Pi) = 2.50662827463100024 if normalized output needed
double gauss (double x, double sigma);

// returns a uniform deviate on the interval ]x1, x2].
double ranuni (double x1, double x2);

// Return a number distributed following a gaussian with sigma
double rangaus (double sigma);

// Simulate detector pulse
// amplitude a, time t, risetime rt, falltime ft
double detpulse (double a, double t, double rt, double ft);

#endif                          /* DSPLIB_H */
