#include "hptimer.h"
#include <cstring>
#include <cfloat>

hpTimer::hpTimer()
{
  memset(&tv_start, 0, sizeof(tv_start));
  memset(&tv_stop, 0, sizeof(tv_stop));
  is_running = false;
  calibration = 0;
}

void hpTimer::calibrate()
{
  const int ni = 100;
  double m = DBL_MAX;
  double dt;
  for (int i = 0; i<ni; i++) {
      start();
      dt = elapsed();
      if (dt<m) m=dt;
  }
  calibration = m;
}

void hpTimer::start()
{
  gettimeofday(&tv_start, NULL);
  is_running = true;
}
void hpTimer::stop()
{
  is_running = false;
  gettimeofday(&tv_stop, NULL);
}
double hpTimer::elapsed() const
{
  struct timeval tv;
  if (is_running)
        gettimeofday(&tv, NULL);
  else
        tv = tv_stop;
  return (tv.tv_sec-tv_start.tv_sec)+1e-6*(tv.tv_usec-tv_start.tv_usec) - calibration;
}
