//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "daqcommon/rawdata.h"

const char *daq_str_dtype(int dt)
{
  switch (dt) {
  case 0x0:
    return ("   DAT 0");
  case 0x1:
    return ("   DAT 1");
  case 0x2:
    return ("   DAT 2");
  case 0x3:
    return ("   DAT 3");
  case 0x4:
    return ("   DAT 4");
  case 0x5:
    return ("   DAT 5");
  case 0x6:
    return ("   DAT 6");
  case 0x7:
    return ("   DAT 7");
  case 0x8:
    return ("  MHDR  ");
  case 0x9:
    return ("  MTRL  ");
  case 0xA:
    return (" EHDR   ");
  case 0xB:
    return (" ETRL   ");
  case 0xC:
    return ("SHDR    ");
  case 0xD:
    return ("STRL    ");
  case 0xE:
    return ("STAT    ");
  case 0xF:
    return ("    DATA");
  default:
    return ("unknown ");
  }
}
