//
//    Copyright 2011 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef CALIBRATIONDATA_H
#define CALIBRATIONDATA_H

#include "singleton.h"

#include <QSettings>

class CalibrationData : public QSettings
{
public:
    CalibrationData(QObject *parent = 0);
//    QVariant get(QString name, quint64 serial, ) const;
//    static QString getCalibrationDataFileName();
    static QString moduleKey(const QString &moduleName, quint64 serialId);
    friend class Singleton<CalibrationData>;
};

class GlobalCalibrationData : public Singleton<CalibrationData>
{
protected:
    GlobalCalibrationData() {}
    friend class Singleton<CalibrationData>;
};

//static CalibrationData &getInstance();

#endif // CALIBRATIONDATA_H
