//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef DBUFSTATE_H
#define DBUFSTATE_H

#include <string>
#include <map>

class DbufState {
public:
    DbufState();
    void clear();
    void clearSpill();
    void clearEvent();
    void clearModule();
    void handleSHDR(unsigned int data);
    void handleSTRL(unsigned int data);
    void handleEHDR(unsigned int data);
    void handleETRL(unsigned int data);
    void handleMHDR(unsigned int data);
    void handleMTRL(unsigned int data);
    int getModuleId() const { return mid; }
    int getEventNumber() const { return en; }
    int getModuleFlags() const { return modflags; }
    std::string getModuleName() const;
    int getModuleSlot() const { return slot; }
    unsigned int getTrigTimestampRaw() const;
    double getTrigTimestamp() const;

    int q;
    int nq;
    int en;
    unsigned int trig_ts_lo;
    unsigned int trig_ts_hi;
    std::map<int, unsigned int> mod_word_count_by_datatype;

protected:
    int mid;
    int slot;
    int modflags;
};

#endif // DBUFSTATE_H
