//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef RAWDUMPER_H
#define RAWDUMPER_H

#include <string>

#include "singleton.h"
#include "DbufState.h"

class QString;

class RawDumper
{
  public:
        RawDumper();
        void clear();
        QString decodeRawDataWord (const unsigned int d);
        QString dump_raw_str(const unsigned int *buf, size_t start, size_t end, size_t mark = -1, bool compress = true);
  protected:
        DbufState dbufState;
};

class GlobalRawDumper : public Singleton<RawDumper>
{
protected:
  GlobalRawDumper(){}
  friend class Singleton<RawDumper>;
};

#endif // RAWDUMPER_H
