#ifndef DECODE_BASE_H
#define DECODE_BASE_H

#include <QtCore/QtGlobal>
#include <string>
#include <map>

class event_t;
class hw_manager;
class base_mod;

class local_base_decoder {
public:
  local_base_decoder(const hw_manager &p, event_t * const event);
  virtual ~local_base_decoder() {}
  virtual void prepare_decode(const unsigned int *f_buf, size_t f_len, int f_first_ch, const base_mod *f_hwmod);
  virtual int decode() = 0;
  virtual void clear();
  virtual void post_decode();
  virtual bool decode_module_header();
  virtual bool decode_module_trailer();
  virtual void print() const;
  virtual void updateDataFormat();
  void map_modules();

protected:
  void addStat(const std::string &name, qint64 count = 1);
  void setStat(const std::string &name, qint64 count = 1);
  void handle_hptdc_error(unsigned int d_raw);

  const unsigned int *buf;
  size_t len; // [0..len], inclusive - size is len+1
//  int nm; // number of modules
  int first_ch; // first channel number
  int error_flag;
  const hw_manager &hwf;
  event_t * const ev;
  const base_mod *hwmod;
//  std::map<int, ddb_key_t> key_by_slot;
};

#endif /* DECODE_BASE_H */
