#ifndef DECODE_BRIC_H
#define DECODE_BRIC_H

#include "decoder/decode_base.h"
/*
struct bric_rawdata_status_t {
  unsigned int tmout:1;
  unsigned int disconnect:1;
  unsigned int dataerr:1;
  unsigned int errprop:1;
  unsigned int reserved:24;
  unsigned int code:4; // 0x7
};
*/
enum {
  BRIC_STATUS_BIT_TIMEOUT = 0x01,
  BRIC_STATUS_BIT_DISCONNECT = 0x02,
  BRIC_STATUS_BIT_DATAERR = 0x04,
  BRIC_STATUS_BIT_ERR_PROP = 0x08,
  BRIC_STATUS_BIT_LCF_TIMEOUT = 0x10,
  BRIC_STATUS_BIT_CRC_ERR = 0x20,
};

enum {
  BRIC_HEADER_BIT_TIMEOUT = 1<<15,
  BRIC_HEADER_BIT_ALIGN_ERR = 1<<14,
  BRIC_HEADER_BIT_OVERFLOW = 1<<13,
  BRIC_HEADER_BIT_ABSENT = 1<<12,
  BRIC_HEADER_BIT_LINKHOST_DISCONNECT = 1<<0,
  BRIC_HEADER_BIT_LINKHOST_RXERROR = 1<<1,
  BRIC_HEADER_BIT_LINKREMOTE_DISCONNECT = 1<<4,
  BRIC_HEADER_BIT_LINKREMOTE_RXERROR = 1<<5,
};

class event_t;
class hw_manager;

class local_dch_decoder: public local_base_decoder {
public:
  local_dch_decoder(const hw_manager &p, event_t * const event)
    : local_base_decoder(p, event) { }
  virtual int decode();
  virtual void print() const;
};

inline int bric_hdr_decode_window_id(unsigned int d) { return (d>>8) & 0xF; }
inline int bric_hdr_decode_branch_id(unsigned int d) { return d & 0xF; }

#endif /* DECODE_BRIC_H */
