
#include "modules/mtdc64_types.h"
#include "hal/mtdc64_mod.h"
#include "decode_mtdc64.h"

int local_mtdc64_decoder::module_nch() const
{
    return MTDC64_NCH;
}

int local_mtdc64_decoder::map_tdcidch2inp(int tdc_id, int tdc_ch) const
{
  int tdcnum = mtdc64_tdcid2tdcnum[tdc_id];
  int ch = isVeryHighResolution()?mtdc64_tdcch2ch_25ps[tdc_ch]:mtdc64_tdcch2ch[tdc_ch];
  return tdcnum*32+ch;
}

int local_mtdc64_decoder::decode_ch(unsigned int d) const
{
  unsigned int id = (d >> 24) & 0xF;
  unsigned int tch = (d >> 19) & 0x1F;
  int ch = map_tdcidch2inp(id, tch);
  return ch;
}
