
#include "modules/phtdc_types.h"
#include "decode_phtdc.h"

int local_phtdc_decoder::map_tdcidch2inp(int tdc_id, int tdc_ch) const
{
  int tdcnum = phtdc_tdcid2tdcnum[tdc_id];
  if (tdcnum == -1) return -1;
  int ch = tdc_ch/2; // ch is &= 0x1F, so no range check here
  return phtdc_tdcid_tdcch_2_ch[tdcnum][ch];
}

int local_phtdc_decoder::decode_ch(unsigned int d) const
{
  unsigned int id = (d >> 24) & 0xF;
  unsigned int tch = (d >> 19) & 0x1F;
  int ch = map_tdcidch2inp(id, tch);
  return ch;
}
