#ifndef DECODE_TDC_H
#define DECODE_TDC_H

#include "decoder/decode_base.h"
#include "decoder/event.h"
#include "hptdc/hptdc_types.h"

class event_t;
class hw_manager;

class local_tdc_decoder: public local_base_decoder {
public:
  local_tdc_decoder(const hw_manager &p, event_t * const event);
  virtual int decode();
  virtual void print() const;
  virtual void updateDataFormat();

protected:

  virtual int module_nch() const = 0;
  virtual int map_tdcidch2inp(int tdc_id, int tdc_ch) const = 0;
  virtual int decode_ch(unsigned int d_raw) const = 0;
  tdc_hits_t combine_hit_edges(const tdc_hits_t &hits);
  bool isVeryHighResolution() const;

  TdcResIndex tdcresindex;
  TdcResIndex tdcpresindex;
  bool pair;
  int edge;
};

#endif /* DECODE_TDC_H */
