
#include "modules/tdc32vl_types.h"
#include "hal/tdc32vl_mod.h"
#include "decode_tdc32vl.h"

int local_tdc32vl_decoder::map_tdcidch2inp(int tdc_id, int tdc_ch) const
{
  int tdcnum = tdc32vl_tdcid2tdcnum[tdc_id];
  int ch = tdc32vl_tdcch2ch[tdc_ch%32];
  return tdcnum*8+ch;
}

int local_tdc32vl_decoder::decode_ch(unsigned int d) const
{
  unsigned int id = (d >> 24) & 0xF;
  unsigned int tch = (d >> 19) & 0x1F;
  int ch = map_tdcidch2inp(id, tch);
  return ch;
}
