
#include "modules/tdc64v_types.h"
#include "hal/tdc64v_mod.h"
#include "decode_tdc64v.h"

int local_tdc64v_decoder::map_tdcidch2inp(int tdc_id, int tdc_ch) const
{
  int tdcnum = tdc64v_tdcid2tdcnum[tdc_id];
  int ch = tdc64v_tdcch2ch[tdc_ch];
  return tdcnum*32+ch;
}

int local_tdc64v_decoder::decode_ch(unsigned int d) const
{
  unsigned int id = (d >> 24) & 0xF;
  unsigned int tch = (d >> 19) & 0x1F;
  int ch = map_tdcidch2inp(id, tch);
  return ch;
}
