
#include "modules/tdc96_types.h"
#include "hal/tdc96_mod.h"
#include "decode_tdc96.h"

int local_tdc96_decoder::map_tdcidch2inp(int tdc_id, int tdc_ch) const
{
  int tdcnum = tdc96_tdcid2tdcnum[tdc_id];
  int ch = tdc96_tdcch2ch[tdc_ch];
  return tdcnum*32+ch;
}

int local_tdc96_decoder::decode_ch(unsigned int d) const
{
  unsigned int id = (d >> 24) & 0xF;
  unsigned int tch = (d >> 19) & 0x1F;
  int ch = map_tdcidch2inp(id, tch);
  return ch;
}
