#ifndef DECODE_TQDC_H
#define DECODE_TQDC_H

#include <vector>

#include "modules/tqdc_types.h"
#include "decoder/decode_base.h"
#include "decoder/event_types.h"
#include "hptdc/hptdc_types.h"

class event_t;
class tqdc_wf_t;
class tqdc_hit_q_t;
class hw_manager;
class tqdc_calibration_set;

class local_tqdc_decoder: public local_base_decoder {
public:
  local_tqdc_decoder(const hw_manager &p, event_t * const event);
  virtual int decode();
  virtual void print() const;

private:
  unsigned int flush_waveforms ();
  unsigned int flush_integrator ();
  TdcResIndex get_tdcresindex() const;
  bool get_tdcpair() const;
  int get_samp_len() const;

  typedef std::map<int, tqdc_wf_t> tmp_wfs_t;
  tmp_wfs_t tmp_wfs;
  typedef std::map<int, tqdc_hit_q_t> tmp_hits_q_t;
  tmp_hits_q_t tmp_hits_q;
};

#endif /* DECODE_TQDC_H */
