#ifndef DECODE_TRIG_H
#define DECODE_TRIG_H

#include "decoder/decode_base.h"

int trig_get_state_by_bit(unsigned int bit);

class event_t;
class hw_manager;

class local_trig_decoder: public local_base_decoder {
public:
  local_trig_decoder(const hw_manager &p, event_t * const event)
    : local_base_decoder(p, event) {}
  virtual int decode();
  virtual void print() const;
};

inline unsigned int trig_d4_decode_ts_lo(unsigned int d) { return (d & 0x00FFFFFF); }
inline unsigned int trig_d5_decode_ts_hi(unsigned int d) { return ((d>>20) & 0xFF); }
inline unsigned int trig_d5_decode_trigbits(unsigned int d) { return (d & 0x000FFFFF); }
inline unsigned int trig_decode_make_ts(unsigned int ts_hi, unsigned int ts_lo) { return (ts_hi<<24) | ts_lo;}

#endif /* DECODE_TRIG_H */
