//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef EVENT_TYPES_H
#define EVENT_TYPES_H

#include <QtCore/QtGlobal>
#include <QVector>
#include <QMap>

enum evtype_t {
  EVT_NORM = 1, // normal event
  EVT_EOB = 2,  // end-of-burtst event
};


// TDC
class tdc_hit_t;
typedef quint32 tdc_cnt_t;
typedef QVector<tdc_hit_t> tdc_hitv_t;
typedef QMap<int, tdc_hitv_t> tdc_hits_t;
typedef QMap<int, tdc_cnt_t> tdc_cnts_t;

// TQDC
class tqdc_hit_q_t;
class tqdc_wf_t;
typedef tdc_hit_t tqdc_hit_t_t;
typedef QVector<short> tqdc_samples_t;
typedef quint32 tqdc_cnt_t;
typedef QVector<tqdc_hit_t_t> tqdc_hitv_t_t;
typedef QMap<int, tqdc_hitv_t_t> tqdc_hits_t_t;
typedef QVector<tqdc_hit_q_t> tqdc_hitv_q_t;
typedef QMap<int, tqdc_hitv_q_t> tqdc_hits_q_t;
typedef QVector<tqdc_wf_t> tqdc_wfv_t;
typedef QMap<int, tqdc_wfv_t> tqdc_wfs_t;
typedef QMap<int, tqdc_cnt_t> tqdc_cnts_t;

// TRIG
typedef quint32 trig_cnt_t;
typedef QMap<int, trig_cnt_t> trig_cnts_t;

// DCH
class dch_window_t;
class dch_branch_t;
typedef QMap<int, dch_window_t> dch_windows_t;
typedef QMap<int, dch_branch_t> dch_branches_t;

// MSC
//typedef QMap<quint64, quint32> msc_point_t;
//typedef quint32 msc_count_t;
//struct msc_counts_t : public QMap<int, msc_count_t> {};
//struct msc_data_t: public QMap<qint64, msc_counts_t> {}; // index is timestamp
struct msc_counts_t : public QVector<int> {};
struct msc_data_t: public QMap<int, msc_counts_t> {}; // index is channel number

#endif // EVENT_TYPES_H
