//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef TQDC_CALIBRATION_SET_H
#define TQDC_CALIBRATION_SET_H

#include <map>

#include "event_types.h"

class tqdc_calibration_set {
public:
  double get_baseline(int ch) const;
  void set_baseline(int ch, double value);
  void add(int ch, double value);
  void add(const tqdc_hits_q_t &hits_q);
  void print() const;
private:
  typedef std::map<int, double> baseline_val_t;
  baseline_val_t baseline_val;
  std::map<int, int> baseline_num;
};

#endif // TQDC_CALIBRATION_SET_H
