#ifndef VMEDAQ_JTAG_IMPL_FVME_H
#define VMEDAQ_JTAG_IMPL_FVME_H

#include "hal/vmedaq_jtag_impl.h"

#include <QtCore/QtGlobal>

class base_hwif;
class base_bmod;

class Jtag_Impl_Options_Vme
{
public:
    Jtag_Impl_Options_Vme(base_hwif *p, unsigned int addr, unsigned int addr_b32);
    base_hwif * const hwif;
    const unsigned int io_addr;
    const unsigned int io_b32_addr;
    const bool enable_32bit_jtag;
};

class Jtag_Impl_Fvme : public Jtag_Impl {

public:
  Jtag_Impl_Fvme(const Jtag_Impl_Options_Vme &p);
  virtual ~Jtag_Impl_Fvme();
//  void set_hwif (base_hwif *p);
//  void set_jtag_address(unsigned int jtag_io_addr, unsigned int jtag_io_b32_addr);
//  virtual void setOptions(Jtag_Impl_Options *p) { options = dynamic_cast<Jtag_Impl_Options_Vme*>(p); }
//  virtual Jtag_Impl_Options *getOptions() { return options; }

  virtual int jtag_io (int tms, int tdi);
#ifdef USE_JTAG32
  virtual void jtag_io_b32_blk (unsigned int count, const unsigned int *tdi32Data, unsigned int *tdo32Data);
#endif
  virtual void jtag_io_b(size_t count, const bool *btms, const bool *btdi, bool *btdo);

  void clearStats();
  void printStats() const;

protected:
  unsigned int get_io_addr() const { return options.io_addr; }
  unsigned int get_io_b32_addr() const { return options.io_b32_addr; }
  base_hwif *getHwif();

#ifdef USE_JTAG32
  int jtag_io_b32 (int tdi);
#endif

private:
  const Jtag_Impl_Options_Vme options;
//  base_hwif *hwif;
  quint64 count_pkt;
  quint64 count_io;
  quint64 count_io_b;
  quint64 count_io_b32;
};

#endif /* VMEDAQ_JTAG_IMPL_FVME_H */
