//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "base_mod_factory.h"
#include "hal/base_mod.h"
#include "modlist.h"

base_mod *base_mod_factory::create(mtype_t id)
{
    base_mod *p = 0;
    switch (id) {
    case MODULE_ID_SLVME:
    case MODULE_ID_ROC48:
    case MODULE_ID_ADLVME:
    case MODULE_ID_PHLOM:
        p = new base_mod ();
        break;
    case MODULE_ID_PHTDC:
        p = new phtdc_mod ();
        break;
    case MODULE_ID_TDC32VL:
        p = new tdc32vl_mod ();
        break;
    case MODULE_ID_TDC64V:
        p = new tdc64v_mod ();
        break;
    case MODULE_ID_TDC96:
        p = new phtdc_mod ();
        break;
    case MODULE_ID_MSC16V:
        p = new msc_mod ();
        break;
    case MODULE_ID_MTDC64:
        p = new mtdc64_mod ();
        break;
    case MODULE_ID_TQDC:
        p = new tqdc_mod ();
        break;
    case MODULE_ID_TRIG:
        p = new trig_mod ();
        break;
    case MODULE_ID_BRIC:
        p = new bric_mod ();
        break;
    default:
        id = MODULE_ID_DUMMY;
        p = new base_mod ();
    }
    if (p)
        p->set_id(id);
    return p;
}
