//
//    Copyright 2011 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef BASE_MOD_TYPES_H
#define BASE_MOD_TYPES_H

#include <QFlags>

enum bmod_task_id_t {
    BMOD_TASK_READ_CONFIG,
    BMOD_TASK_SELFTEST,
    BMOD_TASK_RESET,
    BMOD_TASK_UPDATE_STATUS,
    BMOD_TASK_PREPARERUN,
    BMOD_TASK_CALIBRATION,
    BMOD_TASK_START_RUN,
    BMOD_TASK_POST_START_RUN,
    BMOD_TASK_PRE_STOP_RUN,
    BMOD_TASK_STOP_RUN,
    BMOD_TASK_START_SPILL,
    BMOD_TASK_STOP_SPILL,
    BMOD_TASK_START_OF_BURST,
    BMOD_TASK_END_OF_BURST,
    BMOD_TASK_START_OF_BURST_SIGNAL,
    BMOD_TASK_END_OF_BURST_SIGNAL,
    BMOD_TASK_CLEAR_STATISTICS,
    BMOD_TASK_UPDATE_STATISTICS,
    BMOD_TASK_INTERSPILL_TEST,
};

// Flags
  enum STDMOD_FLAG {
    STDMOD_FLAG_CBLT =          0x00000001,
    STDMOD_FLAG_FIRST =         0x00000002,
    STDMOD_FLAG_MID =           0x00000004,
    STDMOD_FLAG_LAST =          0x00000008,
  //  STDMOD_FLAG_DISABLE =       0x00000010, //<! completely disable module
    STDMOD_FLAG_OVER =          0x04000000, //<! module readout overflow
    STDMOD_FLAG_TESTOK =        0x08000000, //<! module BIST Ok
    STDMOD_FLAG_UNINITIALIZED = 0x10000000, //<! module was never initialized - unknown state
    STDMOD_FLAG_WARN =          0x20000000, //<! module has warnings
    STDMOD_FLAG_ERR =           0x40000000, //<! module in error state
    STDMOD_FLAG_FAIL =          0x80000000, //<! module has failed - replace it
  };
  Q_DECLARE_FLAGS(base_mod_flags, STDMOD_FLAG);
  Q_DECLARE_OPERATORS_FOR_FLAGS(base_mod_flags);

#endif /* BASE_MOD_TYPES_H */
