/*
 * BRIC backend (hardware) declaration
 */

#ifndef BRIC_BMOD_H
#define BRIC_BMOD_H

#include "bric_mod.h"
#include "base_bmod.h"

// board-specific functions
class bric_bmod:public bric_mod, public virtual base_bmod
{
public:
    bric_bmod(const bmod_props &props) : base_bmod(props) {}
    // module actions
    virtual bool detect();
    virtual bool selftest ();
    virtual void reset ();
    virtual void start_run();
    virtual void preparerun();
    virtual bool interspill_test();

private:
    virtual void load_settings(const common_setup_t *p);
    void write_remote_reg(int reg, quint16 data);
    quint16 read_remote_reg(int reg);
};

#endif /* BRIC_BMOD_H */
