#ifndef HPTDC_SETTINGS_H
#define HPTDC_SETTINGS_H

#include <string>

#include "hptdc/hptdc_types.h"

class hptdc_settings {
public:
  hptdc_settings(hptdc_setup_t *ps, int *pmask);
  virtual ~hptdc_settings() {}
//  void set_data_ptr(void *ptr) { s = (hptdc_setup_t *)ptr; }
//  void set_chmask_ptr(void *ptr) { channel_mask = (int *)ptr; }
  virtual void set_defaults();
  void get_id(int *id) const;
  void set_id(int id);
//  void set_param (bool ENABLE_TDC_HEADERS, bool ENABLE_TDC_TRAILERS, int HPTDC_CORE_CLOCK);
  void get_window (int *matchwin, int *latency) const;
  void set_window (int matchwin, int latency);
  void get_pair (bool *pair, int *pres) const;
  void set_pair (bool pair, int pres);
  void get_resolution (TdcResIndex *res) const;
  void set_resolution (TdcResIndex res);
  void get_edge (int *edge) const;
  void set_edge (int edge);
//  void get_flags (int nd, int *flags) const;
//  void set_flags (int flags);
//  void get_hdr_trl (bool *hdr, bool *trl) const;
//  void set_hdr_trl (bool hdr, bool trl);
  void get_hdr (bool *hdr) const;
  void set_hdr (bool hdr);
  void get_trl (bool *trl) const;
  void set_trl (bool trl);
  void get_rcadj (int rcadj[4]) const;
  void set_rcadj (int rcadj[4]);
  virtual void get_ch_enable (int ch, bool *en) const;
  virtual void set_ch_enable (int ch, bool en);
  bool validate_ch(int ch) const {return (ch>=0 && ch<31);}
  virtual bool get_int(int *value, const std::string &tag, unsigned int mch) const;
  virtual bool set_int(int value, const std::string &tag, int mch);

// special
  void set_ttl_clk() {s->bit.enable_ttl_clock = 1; /* 1 = TTL */}
  void set_lvds_clk() {s->bit.enable_ttl_clock = 0; /* 0 = LVDS */}
  void set_ttl_hit() {s->bit.enable_ttl_hit = 1; /* 1 = TTL */}
  void set_lvds_hit() {s->bit.enable_ttl_hit = 0; /* 0 = LVDS */}
  void set_core_clk(hptdc_core_clock_t value) {s->bit.core_clock_source = value;}

// Hardcoded constants
  static int get_min_win();
  static int get_max_win();
  static int get_min_lat();
  static int get_max_lat();


//protected:
  hptdc_setup_t * const s;
  int * const channel_mask;
};

#endif /* HPTDC_SETTINGS_H */
