
#include "daqcommon/daqexc.h"
#include "hal/hw_frontend_shm.h"
#include "hal/hw_ipc.h"

hw_frontend_shm::hw_frontend_shm()
    : sharedSetup(new SharedSetupFrontend())
{
}

hw_frontend_shm::~hw_frontend_shm()
{
    delete sharedSetup;
}

bool hw_frontend_shm::isReadonly() const
{
    return sharedSetup->isReadonly();
}

void hw_frontend_shm::open ()
{
  if (daq_hal_initialized)
    throw exc("hw_frontend_shm::open already open");
  sharedSetup->attach ();
  daq_hal_initialized = true;

//  hws->print();
  create_modules_from_hws();
//  print_summary ();
}

void hw_frontend_shm::close ()
{
  if (!daq_hal_initialized)
    throw exc("hw_frontend_shm::close not open");

  delete_modules();
  daq_hal_initialized = false;
  sharedSetup->detach();
}

void hw_frontend_shm::create_modules_from_hws()
{
  for (int i = 0; i < sharedSetup->get_nent (); i++) {
        common_setup_t *data = sharedSetup->get_data_ptr(i);
        size_t sz = sharedSetup->get_data_size(i);
    insert_module(i, data, sz);
  }
}
