//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef HW_IPC_H
#define HW_IPC_H

#include <cstddef>

class common_setup_t;
class hws_t;
struct hws_hdr_t;
class hw_ipcPrivate;

class hw_ipc {
public:
  enum AccessMode { ReadOnly, ReadWrite };
//  void print() const;
  int get_nent () const;
  common_setup_t *get_data_ptr(int n);
  size_t get_data_size(int n) const;
  int alloc (size_t s); //!< allocate and clear
  void clear();
  void attach ();
  void detach ();
  bool isReadonly() const {return dataAccessMode == ReadOnly;}

private:
  hw_ipcPrivate * const d;

protected:
  hw_ipc (AccessMode mode);
  virtual ~hw_ipc ();
  hws_hdr_t *attach_hws_hdr(AccessMode mode);

  AccessMode hdrAccessMode;
  AccessMode dataAccessMode;
  hws_t * const hws;
};

class SharedSetupBackend: public hw_ipc {
public:
  SharedSetupBackend();
  virtual ~SharedSetupBackend();
};

class SharedSetupFrontend: public hw_ipc {
public:
  SharedSetupFrontend();
  virtual ~SharedSetupFrontend();
};


#endif // HW_IPC_H
