#ifndef HWIF_VME_H
#define HWIF_VME_H

#include "hal/base_hwif.h"
#include <map>

struct vme_cr_t;
struct vme_csr_t;

class hwif_vme : public virtual base_hwif {
public:
    hwif_vme();
    virtual ~hwif_vme() {}
    virtual std::list<hwif_discover_t> discover();
    std::map<int, struct vme_cr_t> find_all_cr();
    void validate_ga(int ga);

protected:
    virtual void read_cr(unsigned int ga, struct vme_cr_t * cr);
    virtual void read_csr(unsigned int ga, struct vme_csr_t * csr);
    virtual void write_csr(unsigned int ga, const struct vme_csr_t * csr);
    static double getSysresetPostDelay();

    // cr/csr not used in base_hwif
    virtual void w_crcsr_d16 (unsigned int addr, int data) = 0;
    virtual void r_crcsr_d16 (unsigned int addr, int *data) = 0;

    const int vme_nst;
};

#endif /* HWIF_VME_H */
