#ifndef HWS_H
#define HWS_H

#include <cstddef>
#include <vector>

enum { MAX_HW_MODULES = 20 };

// Shared memory structures
typedef struct {
  unsigned int magic;
//  mtype_t mt;                   // module type, must be >0
// shm segment to store module data
  size_t sz;                       // shm block size
//  int shmid;                    // shm block id
} hws_ent_t;

struct hws_hdr_t {
  unsigned int magic;
  int nent;                     // number of entries
  hws_ent_t ent[MAX_HW_MODULES]; // ptr to shm
};

class common_setup_t;
// Process memory structures
class hws_t {
public:
    hws_t(hws_hdr_t *p) : hdr(p), data(MAX_HW_MODULES) { for(int i=0; i<MAX_HW_MODULES; i++) data[i] = 0; }
    ~hws_t();
    bool hasSpace() const;
    int count() const;
    int addEntry(void *ptr, size_t size);
    void attachData(int index, void *ptr);
    common_setup_t *get_data_ptr(int n);
    size_t get_data_size(int n) const;
    static bool hdr_valid(const hws_hdr_t *hdr);
//    void print() const;

//protected:
    hws_hdr_t * const hdr;               // ptr to shm
protected:
    std::vector<common_setup_t *>data; // shm segment virtual address (used by shmat, shmdt)
};

bool hws_ent_valid(const hws_ent_t *ent);
void hws_initialize_hdr(hws_hdr_t *hdr);

#endif /* HWS_H */
