
/*
 * MSC backend (hardware) declaration
 */

#ifndef MSC_BMOD_H
#define MSC_BMOD_H

#include "msc_mod.h"
#include "base_bmod.h"
//#include <map>
#include <vector>

typedef std::vector<quint32> msc_counters_t;

class msc_bmod: public base_bmod, public msc_mod {
 public:
    msc_bmod(const bmod_props &props) : base_bmod(props) {}

  // module actions
  virtual bool detect ();
  virtual bool selftest ();
  virtual void reset ();
  virtual void preparerun ();
  virtual void calibration();
//  virtual void start_run ();
//  virtual void stop_run ();
  virtual void end_of_burst_readout();
//  virtual bool interspill_test ();
  virtual double read_temp() { return base_bmod::read_temp();}

 protected:
  enum {NO_FORCE_ZERO = 0, FORCE_ZERO = 1};

// msc
  void dac_exec(const std::vector<int> &cmd);
  static std::vector<int> dac_set_cmd (int ch, int val);
  static std::vector<int> dac_set_all_cmd(int dac);
  static std::vector<int> dac_reset_cmd ();
  static std::vector<int> dac_load_cmd ();
  void dac_reset ();
  void dac_load ();
  void dac_set (int ch, int val);
  void dac_set_all(int dac);
  void dac_set_load(int ch, int dac);
  void dac_set_all_load(int dac);
  void set_thr (int force_zero);
  void load_registers(int force_zero = NO_FORCE_ZERO);
  msc_counters_t get_counters();
  virtual int get_regnumber_test() const;

private:
  double thr_offset(int ch);
};

#endif /* MSC_BMOD_H */
