
/*
 * MSC module
 */

#ifndef MSC_MOD_H
#define MSC_MOD_H

#include "hal/base_mod.h"

class msc_mod : public virtual base_mod
{
public:
    virtual void set_defaults();
    virtual void set_setup(common_setup_t *f_setup, size_t f_size); // fixme
    virtual int get_int(const std::string &tag, unsigned int mch=GET_FIRST_CH) const;
    virtual void set_int(int value, const std::string &tag, int mch=SET_ALL_CH);
    virtual size_t get_setup_size() const;

    static double dac_mv (int value);
    static int dac_value (double mv);

protected:
    virtual void print_private_setup() const;

    double dac_mv_min () const;
    double dac_mv_max () const;
    static int dac_bits();
    static int dac_min();
    static int dac_max();
};

#endif /* MSC_MOD_H */
