
/*
 * MTDC64 backend (hardware) declaration
 */

#ifndef MTDC64_BMOD_H
#define MTDC64_BMOD_H

#include <vector>

#include "hal/mtdc64_mod.h"
#include "tdc_bmod.h"

typedef std::vector<quint32> mtdc64_counters_t;

class mtdc64_bmod: public tdc_bmod, public mtdc64_mod {
  public:
    mtdc64_bmod(const bmod_props &props) : tdc_bmod(props) {}
    virtual void end_of_burst_readout();
    virtual double read_temp() { return base_bmod::read_temp();}

  protected:
//! reimplemented tdc_bmod::map_chtdc2inp()
//! input: tdc_dev (0..N), tdc_ch(0..31)
//! output: module channel number
  virtual int map_chtdc2inp(int tdc_dev, int ch);

  mtdc64_counters_t get_counters ();

};

#endif /* MTDC64_BMOD_H */
