//
//    Copyright 2011 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "hal/oldcalibrationdata.h"

#include <QString>
#include <QDebug>

#include <iostream>

#include "daqcommon/daqexc.h"

void OldCalibrationData::print() const
{
    Q_FOREACH(QString key, par.keys()) {
//        Q_FOREACH(int index, par[key].keys())
            qDebug() << par[key];
    }
}

QVariant OldCalibrationData::getPar(const QString &name, int index) const
{
    if (!par.contains(name)) {
        qDebug() << "Calibration parameter not found: " << name;
        return QVariant();
    }
    if (!par[name].contains(index)) {
        qDebug() << "Calibration parameter " << name << " not found for index " << index;
        return QVariant();
    }
    return par[name][index];
}

void OldCalibrationData::setPar(const QString &name, int index, const QVariant &val)
{
    par[name][index] = val;
}

QVariant OldCalibrationData::getCondition(const QString &name) const
{
    if (!cond.contains(name)) {
        qDebug() << "Calibration condition not found: " << name;
        return QVariant();
    }
    return cond[name];
}

void OldCalibrationData::setCondition(const QString &name, const QVariant &val)
{
    cond[name] = val;
}
