//
//    Copyright 2011 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef CALIBRATIONDATA_H
#define CALIBRATIONDATA_H

#include <QMap>
#include <QString>
#include <QVariant>

class OldCalibrationData
{
public:
    typedef QMap<int, QVariant> par_t;
    typedef QMap<QString, QMap<int, QVariant> > par_map_t;
    typedef QMap<QString, QVariant> cond_map_t;

    void print() const;
    QVariant getPar(const QString &name, int index) const;
    void setPar(const QString &name, int index, const QVariant &val);
    par_map_t getParams() const { return par; }
    void setParams(const par_map_t &set_par){ par = set_par; }

    cond_map_t getConditions() const { return cond; }
    QVariant getCondition(const QString &name) const;
    void setCondition(const QString &name, const QVariant &val);

protected:
    par_map_t par;
    cond_map_t cond;
};

#endif // CALIBRATIONDATA_H
