
/*
 * TDC32VL backend (hardware) implementation
 */


#include "tdc32vl_bmod.h"
#include "modules/tdc32vl_types.h"
#include "daqcommon/daqexc.h"

//! input: tdc_dev (0..N), tdc_ch(0..31)
//! output: module channel number
int tdc32vl_bmod::map_chtdc2inp(int tdc_dev, int ch)
{
  if (tdc_dev < 0 || tdc_dev >= 4) return 0;
  if (ch < 0 || ch >= 32) return 0;
  return tdc_dev*8+tdc32vl_tdcch2ch[ch%32];
}

bool tdc32vl_bmod::detect ()
{
    info_mod("detect");

    // test data bus
    try {
        if (true != testreg32(get_reg_base()+4*get_regnumber_test(), MOD_SELFTEST_LOOPS)) {
            err_mod("Register test failed");
            goto nx;
        }
    }
    catch (exc &e) {
        err_mod(e.what());
        goto nx;
    }
    if (! tdc_bmod::detect()) {
        goto nx;
    }
    return true;
    nx:
    err_mod ("Detect: not found");
    return false;
}

int tdc32vl_bmod::get_regnumber_test() const
{
    return MODULE_REG_TEST;
}
