
/*
 * TDC32VL backend (hardware) declaration
 */

#ifndef TDC32VL_BMOD_H
#define TDC32VL_BMOD_H

#include "hal/tdc32vl_mod.h"
#include "tdc_bmod.h"

class tdc32vl_bmod: public tdc_bmod, public tdc32vl_mod {
public:
    tdc32vl_bmod(const bmod_props &props) : tdc_bmod(props) {}
    // module actions
    virtual bool detect ();

protected:
    virtual double read_temp() { return base_bmod::read_temp();}
    //! reimplemented tdc_bmod::map_chtdc2inp()
    //! input: tdc_dev (0..N), tdc_ch(0..31)
    //! output: module channel number
    virtual int map_chtdc2inp(int tdc_dev, int ch);
    virtual int get_regnumber_test() const;

};

#endif /* TDC32VL_BMOD_H */
