
/*
 * TDC64V backend (hardware) implementation
 */


#include "tdc64v_bmod.h"
#include "modules/tdc64v_types.h"
#include "daqcommon/daqexc.h"

//! input: tdc_dev (0..N), tdc_ch(0..31)
//! output: module channel number
int tdc64v_bmod::map_chtdc2inp(int tdc_dev, int ch)
{
  if (tdc_dev < 0 || tdc_dev >= 2) return 0;
  if (ch < 0 || ch >= 32) return 0;
  return tdc_dev*32+tdc64v_tdcch2ch[ch%32];
}

bool tdc64v_bmod::detect ()
{
    info_mod("detect");

    // test data bus
    try {
        if (true != testreg32(get_reg_base()+4*get_regnumber_test(), MOD_SELFTEST_LOOPS)) {
            err_mod("Register test failed");
            goto nx;
        }
    }
    catch (exc &e) {
        err_mod(e.what());
        goto nx;
    }
    if (! tdc_bmod::detect()) {
        goto nx;
    }
    return true;
    nx:
    err_mod ("Detect: not found");
    return false;
}

int tdc64v_bmod::get_regnumber_test() const
{
    return MODULE_REG_TEST;
}
