
/*
 * TQDC module
 */

#ifndef TQDC_MOD_H
#define TQDC_MOD_H

#include <vector>

#include "hal/tdc_mod.h"

class tqdc_mod : public virtual tdc_mod
{
public:
    virtual void set_defaults();
    virtual void set_setup(common_setup_t *f_setup, size_t f_size); // fixme
    virtual int get_int(const std::string &tag, unsigned int mch=GET_FIRST_CH) const;
    virtual void set_int(int value, const std::string &tag, int mch=SET_ALL_CH);
    virtual size_t get_setup_size() const;
    //HACK
    //  virtual int get_serial() const {int bs = base_mod::get_serial(); if (bs >= 2) return bs; else return ((get_slot() & 8)?1:0);}

    static double dac_mv (int value);
    static int dac_value (double mv);

protected:
    virtual void print_private_setup() const;
    virtual unsigned int tdc_nch() const; // number of tdc channels altogether
    virtual unsigned int tdc_ndev() const; // number of hptdc chips

    virtual int adc_dev_num(int mch) const;
    virtual int hptdc_dev_num(int mch) const;
    double dac_mv_min () const;
    double dac_mv_max () const;
    static int dac_bits();
    static int dac_min();
    static int dac_max();
    void update_hptdc_edge();

};

#endif /* TQDC_MOD_H */
