/*
 * TRIG backend (hardware) declaration
 */

#ifndef TRIG_BMOD_H
#define TRIG_BMOD_H

#include <vector>

#include "trig_mod.h"
#include "base_bmod.h"

enum {
    TRIG_REG_CONTROL = 0,
    TRIG_REG_TRIGSET = 1,
    TRIG_REG_SPILLDEL = 2,
    TRIG_REG_SPILLWIDTH = 3,
    TRIG_REG_TRIGDEL = 4,
    TRIG_REG_TIMERS = 5,
    TRIG_REG_LOGIC = 6,
    TRIG_REG_TEST = 7,
    TRIG_REG_NIMLOGIC = 10,
    TRIG_REG_LVDSENABLE = 11,
    TRIG_REG_PULSERPERIOD = 12,
    TRIG_REG_NIMOUTPUT = 13
};

typedef std::vector<quint32> trig_incnt_t;

#include "hal/mod_regs.h"
/*
class CommonRegs
{
  public:
        CommonRegs() { ctrl.all = 0; status.all = 0; }
        module_ctrl_reg_t ctrl;
        module_status_reg_t status;
};
*/

class TrigRegs;
// board-specific functions
class trig_bmod:public trig_mod, public virtual base_bmod {
public:
    trig_bmod(const bmod_props &props);
    virtual ~trig_bmod();
// module actions
        virtual bool detect();
        virtual bool selftest ();
        virtual void reset ();
        virtual void preparerun();
        virtual void end_of_burst_readout();
        virtual bool interspill_test();
        virtual void start_spill();
        virtual void stop_spill();

protected:
  virtual module_status_reg_t get_status_reg();
  void load_trigset();

  TrigRegs * const regs;

private:
//  virtual void set_reg (unsigned int reg, int data);
//  virtual void get_reg (unsigned int reg, int *data);
////	virtual void get_reg (unsigned int reg, int *data) {get_reg16(reg, data);}
////	virtual void set_reg (unsigned int reg, int data) {set_reg16(reg, data);};
        virtual void load_settings(const common_setup_t *p);
        virtual trig_incnt_t get_incnt();
//	virtual void set_dreg();
//	virtual void get_dreg();
//	virtual void write_ram (int data[]);
};

#endif /* TRIG_BMOD_H */
