
#include "vmedaq_jtag_impl.h"

int Jtag_Impl::jtag_io_b32 (int tdi)
{
  int tdo = 0;
  for (int b=0; b<32; b++) {
    int tdobit = jtag_io (0, tdi&(1<<b)?1:0); // TMS=0
    tdo |= tdobit?(1<<b):0;
  }
  return tdo;
}

void Jtag_Impl::jtag_io_b32_blk (unsigned int count, const unsigned int *tdi32Data, unsigned int *tdo32Data)
{
  for (unsigned int n=0;n<count;n++) {
          unsigned int tdi32 = tdi32Data?tdi32Data[n]:0;
          unsigned int tdo32 = jtag_io_b32(tdi32);
          if (tdo32Data)
                tdo32Data[n] = tdo32;
  }
}

void Jtag_Impl::jtag_io_b(size_t count, const bool *btms, const bool *btdi, bool *btdo)
{
  for (size_t i=0; i<count; i++) {
        int tms = btms?btms[i]:0;
        int tdi = btdi?btdi[i]:0;
        int tdo = jtag_io(tms, tdi);
        if (btdo)
          btdo[i] = tdo;
  }
}
