//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef HTPDC_CHIP_H
#define HTPDC_CHIP_H

const int TDC_IR_BITS = 5;           /* Instruction register bits */

const int HPTDC_I_EXTEST   = 0x00;   /* Boundary scan for test of inter-chip connections */
const int HPTDC_I_IDCODE   = 0x11;   /* Scan out of chip identification code */
const int HPTDC_I_SAMPLE   = 0x12;   /* Sample of all chip pins via boundary scan registers */
const int HPTDC_I_INTEST   = 0x03;   /* Using boundary scan registers to test chip itself */
const int HPTDC_I_BIST     = 0x14;   /* Memory self tests (production testing) */
const int HPTDC_I_SCAN     = 0x05;   /* Scan of all internal flip-flops (production testing) */
const int HPTDC_I_Readout  = 0x17;   /* Read of TDC output data */
const int HPTDC_I_Setup    = 0x18;   /* Load/read of setup data */
const int HPTDC_I_Control  = 0x09;   /* Load/read of control information */
const int HPTDC_I_Status   = 0x0A;   /* Read of status information */
const int HPTDC_I_Coretest = 0x1B;   /* Access to internal coretest scan registers (production testing) */
const int HPTDC_I_BYPASS   = 0x1F;   /* Bypass */

#endif // HTPDC_CHIP_H
