//
//    Copyright 2011 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include <QDebug>
#include "bric_types.h"

bric_setup_t::bric_setup_t()
    : common_setup_t()
{
    win_enable = 0xFFFF;
    branch_size_limit_index = 1;
    data_shift_period = 20;
    data_strobe_delay = data_shift_period-5;
}

QDebug operator<<(QDebug dbg, const bric_setup_t &s)
{
    dbg.nospace() << static_cast<const common_setup_t &>(s);
    dbg.nospace() << " bric_setup:\n";
    dbg.nospace() << "  win_enable = " << s.win_enable << ", branch_size_limit_index = " << s.branch_size_limit_index;
    dbg.nospace() << "\n";
    return dbg.maybeSpace();
}
