//
//    Copyright 2011 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef _BRIC_TYPES_H
#define _BRIC_TYPES_H

#include "daqcommon/hal_types.h"

enum {BRIC_NCH = 2};

//const double BRIC_STEP = 0.2*1e-6;

#pragma pack(push,4)
class bric_setup_t : public common_setup_t {
public:
  bric_setup_t();
  quint16 win_enable;
  quint16 branch_size_limit_index;
  quint8 data_strobe_delay;
  quint8 data_shift_period;
};
#pragma pack(pop)

class QDebug;
QDebug operator<<(QDebug dbg, const bric_setup_t &s);

// BRICBOX Link Control Frame user defined
#pragma pack(push, 1)
typedef union {
  unsigned int all;
  struct {
    unsigned int reserved1:3;
    unsigned int sf_err_bit:1; // [3]
    unsigned int bric_ready:1; // [4]
    unsigned int rx_error:1; // [5]
    unsigned int reserved2:2;
    unsigned int b1_absent:1; // [8]
    unsigned int b2_absent:1; // [9]
    unsigned int b1_overflow:1; // [10]
    unsigned int b2_overflow:1; // [11]
    unsigned int b1_align_err:1; // [12]
    unsigned int b2_align_err:1; // [13]
    unsigned int b1_timeout:1; // [14]
    unsigned int b2_timeout:1; // [15]
  } bit;
} bricbox_lcf_t;
#pragma pack(pop)

#endif /* _BRIC_TYPES_H */
