//
//    Copyright 2011 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef _MTDC64_TYPES_H
#define _MTDC64_TYPES_H

#include <vector>

#include "modules/tdc_types.h"
#include "hptdc/hptdc_types.h"

enum { MTDC64_NCH = 64 };
enum { MTDC64_NDEV = 2 };

#if (MTDC64_NCH > TDC_MAXNCH)
# error
#endif
#if (MTDC64_NDEV > TDC_MAXDEV)
# error
#endif

const int mtdc64_tdcid2tdcnum[16] = {
  -1,  1,  0, -1,  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
};
const int mtdc64_tdcch2ch[32] = {
   0,  16,  1,  17,   2,  18,   3,  19,   4,  20,   5,  21,  6,  22,   7,  23,
   8,  24,  9,  25,  10,  26,  11,  27,  12,  28,  13,  29, 14,  30,  15,  31
};
const int mtdc64_tdcch2ch_25ps[32] = {
   0,   0,  0,   0,   2,   2,   2,   2,   4,   4,   4,   4,  6,   6,   6,   6,
   8,   8,  8,   8,  10,  10,  10,  10,  12,  12,  12,  12, 14,  14,  14,  14
};

class mtdc64_setup_t : public tdc_setup_t {
public:
};

class QDebug;
QDebug operator<<(QDebug dbg, const mtdc64_setup_t &s);

enum { MTDC64_N_COUNTERS = MTDC64_NCH };

#endif /* MTDC64_TYPES_H */
