//
//    Copyright 2011 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef _PHTDC_TYPES_H
#define _PHTDC_TYPES_H

#include "modules/tdc_types.h"
#include "hptdc/hptdc_types.h"

enum { PHTDC_NCH = 64 };
enum { PHTDC_NDEV = 4 };

#if (PHTDC_NCH > TDC_MAXNCH)
# error
#endif
#if (PHTDC_NDEV > TDC_MAXDEV)
# error
#endif

const int phtdc_tdcid_tdcch_2_ch[4][16] = {   // map ntdc, tdcch/2 to fp-num
    {
      0x17, 0x16, 0x07, 0x06,
      0x15, 0x14, 0x05, 0x04,
      0x13, 0x12, 0x03, 0x02,
      0x11, 0x10, 0x01, 0x00},
    {
      0x1F, 0x1E, 0x0F, 0x0E,
      0x1D, 0x1C, 0x0D, 0x0C,
      0x1B, 0x1A, 0x0B, 0x0A,
      0x19, 0x18, 0x09, 0x08},
    {
	0x37, 0x36, 0x27, 0x26,
	0x35, 0x34, 0x25, 0x24,
	0x33, 0x32, 0x23, 0x22,
	0x31, 0x30, 0x21, 0x20},
	{
	  0x3F, 0x3E, 0x2F, 0x2E,
	  0x3D, 0x3C, 0x2D, 0x2C,
	  0x3B, 0x3A, 0x2B, 0x2A,
	  0x39, 0x38, 0x29, 0x28}
};

const int phtdc_tdcid2tdcnum[16] = {
  -1,  0,  1, -1,  2, -1, -1, -1, 3, -1, -1, -1, -1, -1, -1, -1
};

class phtdc_setup_t : public tdc_setup_t {
public:
};

class QDebug;
QDebug operator<<(QDebug dbg, const phtdc_setup_t &s);

#endif /* PHTDC_TYPES_H */
