//
//    Copyright 2011 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef _TDC64V_TYPES_H
#define _TDC64V_TYPES_H

#include "modules/tdc_types.h"
#include "hptdc/hptdc_types.h"

enum { TDC64V_NCH = 64 };
enum { TDC64V_NDEV = 2 };

#if (TDC64V_NCH > TDC_MAXNCH)
# error
#endif
#if (TDC64V_NDEV > TDC_MAXDEV)
# error
#endif

const int tdc64v_tdcid2tdcnum[16] = {
  -1,  0,  1, -1,  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
};

// Bug: TDC64V PCB
//const int tdc64v_tdcch2ch[32] = {
//  31,  15,  30,  14,  29,  13,  28,  12,  27,  11,  26,  10,  25,   9,   24,   8,
//  23,   7,  22,   6,  21,   5,  20,   4,  19,   3,  18,   2,  17,   1,   16,   0
//};

const int tdc64v_tdcch2ch[32] = {
  31,  15,  30,  14,  13,  29,  28,  12,  11,  27,  26,  10,  25,   9,   24,   8,
  23,   7,  22,   6,  21,   5,  20,   4,  19,   3,  18,   2,  17,   1,   16,   0
};

class tdc64v_setup_t : public tdc_setup_t {
public:
};

class QDebug;
QDebug operator<<(QDebug dbg, const tdc64v_setup_t &s);

#endif /* TDC64V_TYPES_H */
