//
//    Copyright 2011 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef _TDC96_TYPES_H
#define _TDC96_TYPES_H

#include "modules/tdc_types.h"
#include "hptdc/hptdc_types.h"

enum { TDC96_NCH = 96 };
enum { TDC96_NDEV = 3 };

#if (TDC96_NCH > TDC_MAXNCH)
# error
#endif
#if (TDC96_NDEV > TDC_MAXDEV)
# error
#endif

const int tdc96_tdcid2tdcnum[16] = {
  -1,  0,  1, -1,  2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
};
const int tdc96_tdcch2ch[32] = {
   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31
};

class tdc96_setup_t : public tdc_setup_t {
public:
};

class QDebug;
QDebug operator<<(QDebug dbg, const tdc96_setup_t &s);

#endif /* TDC96_TYPES_H */
