//
//    Copyright 2011 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include <QDebug>
#include "tdc_types.h"

QDebug operator<<(QDebug dbg, const tdc_setup_t &s)
{
    dbg.nospace() << static_cast<const common_setup_t &>(s);
    dbg.nospace() << " tdc_setup:\n";
    dbg.nospace() << "  ch_enable {";
    for (int i=0; i<s.nch; i++)
        dbg.nospace() << s.ch_enable[i] << " ";
    dbg.nospace() << "}\n";
    dbg.nospace() << "  matchwin " << s.matchwin << "\n";
    dbg.nospace() << "  latency " << s.latency << "\n";
    return dbg.maybeSpace();
}
