//
//    Copyright 2011 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include <QDebug>
#include "trig_types.h"

QDebug operator<<(QDebug dbg, const trig_setup_t &s)
{
    dbg.nospace() << static_cast<const common_setup_t &>(s);
    dbg.nospace() << " trig_setup:\n";
    dbg.nospace() << "  input_enable {";
    for (int i=0; i<TRIG_N_INPUTS; i++)
        dbg.nospace() << (int)(s.input_enable[i]) << " ";
    dbg.nospace() << "}\n";
    dbg.nospace() << "  in_shape " << s.in_shape << " ";

    dbg.nospace() << "  ch_delay {";
    for (int i=0; i<s.nch; i++)
        dbg.nospace() << s.ch_delay[i] << " ";
    dbg.nospace() << "}\n";
    dbg.nospace() << "  ch_enable {";
    for (int i=0; i<s.nch; i++)
        dbg.nospace() << s.ch_enable[i] << " ";
    dbg.nospace() << "}\n";
    dbg.nospace() << "  spill_delay " << s.spill_delay << "\n";
    dbg.nospace() << "  spill_duration " << s.spill_duration << "\n";
    dbg.nospace() << "  spill_repeat " << s.spill_repeat << "\n";
    // TODO
    return dbg.maybeSpace();
}
