#ifndef _DATAPLOT_H
#define _DATAPLOT_H

#include <qwt/qwt_plot.h>
#include <qwt/qwt_plot_curve.h>
#include <QSharedPointer>
#include <map>

class QwtPlotMarker;
class QwtSymbol;
class QPen;

const unsigned int DataPlot_NCH = 32;
const int rgbcmap[DataPlot_NCH][3] = {
  {255, 150, 0},
  {255, 0, 0},
  {255, 0, 190},
  {110, 0, 190},
  {0, 100, 255},
  {137, 137, 255},
  {0, 200, 200},
  {0, 190, 0}
};

class DataPlot : public QwtPlot
{
public:
  typedef QSharedPointer<QwtPlotCurve> my_curve_t;

  DataPlot (QWidget * parent = 0);
  ~DataPlot ();
//  virtual void setpoints (int ch, const double *inx, const double *iny, int len);
  void clearpoints (int ch);
  virtual void copypoints (int ch, const double *inx, const double *iny, int len);
  virtual void setstyle (int ch, int style, int options);
  virtual void setname (int ch, const char *name);
  virtual void setSymbol (int ch, const QwtSymbol &s);
  virtual void setPen (int ch, const QPen &p);
  virtual void setStyle (int ch, QwtPlotCurve::CurveStyle s);
  my_curve_t getCurve (int ch);

private:
  typedef std::map< int, my_curve_t > curves_t;

  curves_t curves;
  QwtPlotMarker * const mark_y0;
//  long curv[DataPlot_NCH];
};


#endif /* _DATAPLOT_H */
