//
//    Copyright 2003-2011 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef HISTWIDGET_H
#define HISTWIDGET_H

#include <QWidget>
#include <vector>

namespace Ui {
class HistWidget;
}

//class QAbstractItemModel;
class HistInfoTableModel;
class th1;

class HistWidget : public QWidget
{
    Q_OBJECT
    
public:
    explicit HistWidget(QWidget *parent = 0);
    ~HistWidget();

public slots:
    void setData(const th1 &p);
    void save_to_file();
    virtual void show();
    void update();
    void setLogY(bool state);
    void setShowFit(bool state);

private slots:
    void on_checkBoxGaussFit_toggled(bool checked);

private:
    Ui::HistWidget *ui;

    HistInfoTableModel * const model;
    th1 * const h; // cached histogram data
    std::vector<double> px, py, pfx, pfy;
    double value, mean, sigma, base, scaler;
    QString fn;
    unsigned int alloc_nbins;
    bool plot_modified;
    bool enableLogY;
    bool enableFit;
};

#endif // HISTWIDGET_H
