//
//    Copyright 2003-2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef VMEDAQ_GUI_TDCHUI_TDCCTRLGUI_H
#define VMEDAQ_GUI_TDCHUI_TDCCTRLGUI_H

#include <QWidget>

class hw_manager;

namespace Ui {
    class TdcCtrlGuiBase;
};

class TdcCtrlGui : public QWidget
{
    Q_OBJECT

public:
    explicit TdcCtrlGui(QWidget *parent = 0);
    virtual ~TdcCtrlGui();
    void setHwf(hw_manager *p);

Q_SIGNALS:
    void valueChanged(const QString &, const QVariant &);
    void resolutionChanged();
    void dataFormatChanged();

private:
    int get_int( const QString &name );
    void set_int( const QString &name, int i );
    void updateTextLabels();
    void updatePermissions();
    void setEdge();
    void readHwf();

private Q_SLOTS:
    void setValue( const QString &name, const QVariant &val );
    void sb_tdc_win_valueChanged( int value );
    void sb_tdc_lat_valueChanged( int value );
    void chg_tdc_rc( unsigned int n, int value );
    void chg_tdc_rc0( int value );
    void chg_tdc_rc1( int value );
    void chg_tdc_rc2( int value );
    void chg_tdc_rc3( int value );
    void cb_tdc_edge_changed( int mask, bool state );
    void cb_tdc_lead_toggled( bool state );
    void cb_tdc_trail_toggled( bool state );
    void cb_tdc_en_hdr_toggled( bool state );
    void cb_tdc_en_trl_toggled( bool state );
    void cb_tdc_res_activated( int item );
    void cb_tdc_pres_activated( int );
    void on_radioButton_Leading_toggled(bool);
    void on_radioButton_Trailing_toggled(bool);
    void on_radioButton_LeadTrail_toggled(bool);
    void on_radioButton_Pair_toggled(bool);

private:
    Ui::TdcCtrlGuiBase * const ui;
    hw_manager *hwf; // FIXME: cannot pass in ctor, design bug
};

#endif /* VMEDAQ_GUI_TDCHUI_TDCCTRLGUI_H */
