//
//    Copyright 2003-2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "wfplot.h"
#include "waveformview.h"
#include "ui_waveformviewbase.h"

WaveformView::WaveformView(QWidget* parent)
    : QWidget(parent),
    ui(new Ui::WaveformViewBase)
{
    ui->setupUi(this);
}

WaveformView::~WaveformView()
{
    delete ui;
}

void WaveformView::setGain( int d )
{
    setup.gain = d;
}


void WaveformView::setAutoscale( bool b )
{
    setup.autoscale = b;
}


void WaveformView::setOffset( int d )
{
    setup.offset = d;
}

void WaveformView::remap_channels()
{
  // build map
  // create (but don't delete) curves
  int nchannels = wfm.size();

  for (int i=0; i<nchannels; i++)
      chmap.set(i, i);
}


void WaveformView::update()
{
/*
// get data from model and put to waveformPlot
// find which waveformPlot curves are unused
// model has it's own channel numbering
  for (int i=0;i<wfm.size();i++) {
        const WaveformData &wd = wfm.get(i);
        int waveformPlot_ch = chmap.hw_to_waveformPlot(wd.c);
  }
//  waveformPlot->setData();
  waveformPlot->update();
*/
/*
// curve[n] may have 3 states: NULL, hidden, shown.
// All existing curves, shown and hidden
//  std::map<int, WFCurve> all_curves;

// make map of new shown curves
  std::map<int, bool> to_show;
  for (int i=0;i<wfm.size();i++) {
        const WaveformData &wd = wfm.get(i);
        int id = chmap.hw_to_waveformPlot(wd.c);
//	to_show[waveformPlot_ch] = true;
        WFCurve c(waveformPlot->curves[id]);
        if (waveformPlot->curves[id] == NULL) {
          // insert new curve
          QwtPlotCurve *crv = new QwtPlotCurve();
          crv->attach(waveformPlot);
          waveformPlot->curves[id] = crv;
        }
  }

*/
// find which curves to hide

//  waveformPlot.setAllData(wd);
  ui->waveformPlot->replot();
}
void WaveformView::clear()
{
  ui->waveformPlot->clear();
}

/*
void WaveformView::simulate()
{
  wfm.simulate();
  waveformPlot->setAllData(wfm.get());
  stats->print();
}
*/

void WaveformView::setWaveformData( const WaveformDataAll &w )
{
//  wfm.set(w);
  ui->waveformPlot->setAllData(w);
//  stats->print();
}
