//
//    Copyright 2003-2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef VMEDAQ_GUI_WFVIEW_WAVEFORMVIEW_H
#define VMEDAQ_GUI_WFVIEW_WAVEFORMVIEW_H

#include <QWidget>

#include "waveformviewsetup.h"
#include "wfdata.h"

namespace Ui {
    class WaveformViewBase;
};

class WaveformView: public QWidget
{

    Q_OBJECT

public:
    explicit WaveformView(QWidget* parent=0);
    virtual ~WaveformView();
    void setWaveformData(const WaveformDataAll &w);
    void update();
    void clear();

private:
    void remap_channels();

    Ui::WaveformViewBase * const ui;
    WaveformViewSetup setup;
    WaveformModel wfm;
    WFChannelMap chmap;

private Q_SLOTS:
    void setGain( int d );
    void setAutoscale( bool b );
    void setOffset( int d );

};

#endif /* VMEDAQ_GUI_WFVIEW_WAVEFORMVIEW_H */
