#ifndef WAVEFORMVIEWSETUP_H
#define WAVEFORMVIEWSETUP_H

#include <map>
#include <qobject.h>

class WFChannelMap
{
public:
    int hw_to_plot(int plot_c) {return map_h2p[plot_c];} //!< map hardware channel to plot channel, fast
    //	int plot_to_hw(int plot_c); //!< slow!!

    void set(int hw_c, int plot_c) {map_h2p[hw_c] = plot_c;} //!< establish map
    void clear() {map_h2p.clear();}

private:
    std::map<int, int> map_h2p; // hardware-to-plot channel map
};

class WaveformViewSetup: public QObject
{
public:
    WaveformViewSetup();

    double gain;
    double offset;
    bool autoscale;
};

#endif /* WAVEFORMVIEWSETUP_H */
