#ifndef WFDATA_H
#define WFDATA_H

#include <vector>
#include <string>

class point_t
{
  public:
    point_t(): x(0), y(0) {}
    point_t(double px, double py): x(px), y(py) {}
        double x;
        double y;
};

class WaveformData {
public:
  WaveformData() {c=0;}
  WaveformData(const WaveformData&w) {copyObject(w);}
  void simulate();
  void print() const;

  WaveformData& operator=(const WaveformData&w) {if (&w!=this) copyObject(w); return *this;}

  unsigned int c; // channel
  std::vector<point_t> p; // points
  std::vector<double> t; // time marks
  std::string name;

private:
  void copyObject(const WaveformData&w) {c=w.c; p=w.p; t=w.t; name=w.name;}
};

typedef std::vector<WaveformData> WaveformDataAll;

class WaveformModel {
public:
//  void simulate();
  void resize(unsigned int n) {wd.resize(n);}
  WaveformData get(int channel) const {return wd[channel];}
  WaveformDataAll get() const {return wd;}
  void set(const WaveformDataAll&w) {wd = w;}
  int size() const {return wd.size();} // number of waveforms

protected:
  WaveformDataAll wd;
//  StatsManager stats;
};

class WaveformDataSimulator
{
  public:
    WaveformDataAll run();
};

#endif /* WFDATA_H */
