#ifndef WFPLOT_H
#define WFPLOT_H

#include <QVector>
#include <QMap>
#include <QSharedPointer>
#include <qwt/qwt_plot.h>
class QwtPlotCurve;
class QwtPlotMarker;
#include "wfdata.h"

/*
class WFCurve: public QwtPlotCurve
{
  public:
	int channel;
//	WFCurve() { crv = new QwtPlotCurve();}
//	WFCurve(const WFCurve&p) { if (p!=this) p.}
//	~WFCurve() {if (crv->plot()) crv->detach(); delete crv;}
//	bool shown() const {return plot() != 0;}

//    QwtPlotCurve *crv;
};
*/

class WFPlot: public QwtPlot
{
  typedef QSharedPointer<QwtPlotCurve> WFCurve;
  typedef QSharedPointer<QwtPlotMarker> WFMarker;
  typedef QMap<int, WFCurve> curves_t;
  typedef QMap<int, WFMarker> markers_t;

  public:
    WFPlot(QWidget *p);

//! Add or reuse curve associated with channel n
//    void setData(unsigned int id, const double *px, const double *py, unsigned int len);
//    void setNumCurves(const unsigned int n);
//	WFCurve findCurve(int id) {return curves[id];}
//	void setData(const WaveformData &);
	void setAllData(const WaveformDataAll &);
	void clear();

  private:
	curves_t curves;
	markers_t markref;
        QVector<QColor> colormap;
};

#endif /* WFPLOT_H */
